import { MidwayConfig } from '@midwayjs/core';
const ip = '127.0.0.1';
const project = 'jcyjdtglpt';
const studio = 'studioadmin';
export default {
  // use for cookie sign key, should change to your own and keep security
  keys: '1672292154640_555',
  koa: {
    globalPrefix: `/${project}/v1/api`,
  },
  swagger: {
    swaggerPath: `/dev/${project}/v1/api/doc`,
  },
  mongoose: {
    dataSource: {
      default: {
        uri: `mongodb://${ip}:27017/${project}`,
        options: {
          user: 'admin',
          pass: 'admin',
          authSource: 'admin',
          useNewUrlParser: true,
        },
        entities: ['./entity'],
      },
      studio: {
        uri: `mongodb://${ip}:27017/${studio}`,
        options: {
          user: 'admin',
          pass: 'admin',
          authSource: 'admin',
          useNewUrlParser: true,
        },
        entities: ['./entityStudio'],
      },
      lab: {
        uri: `mongodb://${ip}:27017/free-label`,
        options: {
          user: 'admin',
          pass: 'admin',
          authSource: 'admin',
          useNewUrlParser: true,
        },
        entities: ['./entityLab'],
      },
      project: {
        uri: `mongodb://${ip}:27017/lab_project`,
        options: {
          user: 'admin',
          pass: 'admin',
          authSource: 'admin',
          useNewUrlParser: true,
        },
        entities: ['./entityProject'],
      },
    },
  },
  redis: {
    client: {
      port: 6379, // Redis port
      host: '120.48.146.1', // Redis host
      password: '123456',
      db: 4,
    },
  },
  axios: {
    clients: {
      email: {
        baseURL: 'http://basic.waityou24.cn/semail/api',
      },
      lab: {
        baseURL: 'http://127.0.0.1:13002/freeLabel/api',
      },
      project: {
        baseURL: 'http://127.0.0.1:13003/freeLabel/project/v1/api',
      },
      scientist: {},
    },
  },
} as MidwayConfig;
