import { Controller, Get, Inject } from '@midwayjs/decorator';
import { Context } from '@midwayjs/koa';
import { ApiResponse, ApiTags } from '@midwayjs/swagger';
const assert = require('assert');
import { JwtService } from '@midwayjs/jwt';
import get = require('lodash/get');
@ApiTags(['解析token'])
@Controller('/token')
export class TokenController {
  @Inject()
  jwtService: JwtService;
  @Inject()
  ctx: Context;

  @Get('/tokenView')
  @ApiResponse({})
  async tokenView() {
    const token = get(this.ctx, 'request.header.token');
    assert(token, '缺少token信息');
    const ui: any = await this.jwtService.decode(token);
    let result :any;
    if (ui.role_type === '0' || ui.role_type === '1') {
      result = { _id: ui._id, name: ui.name, role_type: ui.role_type, role: ui.role };
    } else if (ui.role_type === '2') {
      result = { _id: ui._id, nick_name: ui.nick_name, role_type: ui.role_type, unit: ui.unit, role: ui.role, lab_id: ui.lab_id, basic_id: ui.basic_id };
    } else if (ui.role_type === '3') {
      result = { _id: ui._id, name: ui.name, role_type: ui.role_type,is_studio:ui.is_studio, role: ui.role };
    }
    return result;
  }
}
