import { Body, Controller, Del, Get, Inject, Param, Post, Query } from '@midwayjs/decorator';
import { BaseController } from 'free-midway-component';
import { UnitStudioApplyService } from '../service/unitStudioApply.service';
import {
  CreateDTO_unitStudioApply,
  CreateVO_unitStudioApply,
  FetchVO_unitStudioApply,
  QueryDTO_unitStudioApply,
  QueryVO_unitStudioApply,
  UpdateDTO_unitStudioApply,
  UpdateVO_unitStudioApply,
} from '../interface/unitStudioApply.interface';
import { ApiResponse, ApiTags, ApiQuery } from '@midwayjs/swagger';
import { Validate } from '@midwayjs/validate';
@ApiTags(['依托单位申请科学家工作室权限表'])
@Controller('/unitStudioApply')
export class UnitStudioApplyController extends BaseController {
  @Inject()
  service: UnitStudioApplyService;

  @Post('/')
  @Validate()
  @ApiResponse({ type: CreateVO_unitStudioApply })
  async create(@Body() data: CreateDTO_unitStudioApply) {
    const result = await this.service.create(data);
    return result;
  }
  @Get('/')
  @ApiQuery({ name: 'query' })
  @ApiResponse({ type: QueryVO_unitStudioApply })
  async query(@Query() filter: QueryDTO_unitStudioApply, @Query('skip') skip: number, @Query('limit') limit: number) {
    const data = await this.service.query(filter, { skip, limit, sort: { 'meta.createdAt': -1 } });
    const list = [];
    for (const i of data) {
      const nd = new QueryVO_unitStudioApply(i, filter);
      list.push(nd);
    }
    const total = await this.service.count(filter);
    return { data: list, total };
  }

  @Get('/:id')
  @ApiResponse({ type: FetchVO_unitStudioApply })
  async fetch(@Param('id') id: string) {
    const data = await this.service.fetch(id);
    const result = new FetchVO_unitStudioApply(data);
    return result;
  }

  @Post('/:id')
  @Validate()
  @ApiResponse({ type: UpdateVO_unitStudioApply })
  async update(@Param('id') id: string, @Body() body: UpdateDTO_unitStudioApply) {
    const result = await this.service.updateOne(id, body);
    return result;
  }

  @Del('/:id')
  @Validate()
  async delete(@Param('id') id: string) {
    await this.service.delete(id);
    return 'ok';
  }
  async createMany(...args: any[]) {
    throw new Error('Method not implemented.');
  }

  async updateMany(...args: any[]) {
    throw new Error('Method not implemented.');
  }

  async deleteMany(...args: any[]) {
    throw new Error('Method not implemented.');
  }
}
