import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'dictData' },
})
export class DictData extends BaseModel {
  @prop({ required: false, index: true, zh: '字典排序' })
  dict_sort: number;
  @prop({ required: false, index: true, zh: '字典内容名' })
  dict_label: string;
  @prop({ required: false, index: false, zh: '字典内容值' })
  dict_value: string;
  @prop({ required: false, index: true, zh: '字典索引类型' })
  dict_type: string;
  @prop({ required: false, index: true, zh: '是否默认', remark: '0:非默认;1:默认' })
  is_default: string;
  @prop({ required: false, index: true, zh: '状态', remark: '0:正常;1禁用', default: '0' })
  status: string;
}
