import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'unit' },
})
export class Unit extends BaseModel {
  // @prop({ required: false, index: false, zh: '昵称' })
  // nick_name: string;
  @prop({ required: false, index: true, zh: '账号', unique: true })
  account: string;
  @prop({ required: false, index: true, zh: '负责人身份证号', unique: true })
  card: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '负责人姓名' })
  name: string;
  @prop({ required: false, index: false, zh: '负责人邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '负责人手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '单位全称' })
  unit_name: string;
  @prop({ required: false, index: false, zh: '单位地址' })
  unit_address: string;
  @prop({ required: false, index: false, zh: '负责人委任证明' })
  prove: Array<any>;
  @prop({ required: false, index: false, zh: '角色' })
  role: Array<any>;
  @prop({ required: false, index: true, zh: '审核状态', remark: '字典:studio_status', default: '0' })
  exam_status: string;
  @prop({ required: false, index: true, zh:'是否入驻科学家工作室', default: 'N' })
  is_studio: string
}
