import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'user' },
})
export class User extends BaseModel {
  @prop({ required: false, index: false, zh: '昵称' })
  nick_name: string;
  @prop({ required: false, index: true, zh: '账号', unique: true })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '邮箱' })
  email: string;
  @prop({
    required: false,
    index: true,
    zh: '单位',
    remark: '可以是企业名称,也可以是依托单位id',
  })
  unit: string;
  @prop({ required: false, index: false, zh: '单位地址' })
  unit_address: string;
  @prop({ required: false, index: false, zh: '角色' })
  role: Array<any>;
  @prop({ required: false, index: true, zh: '审核状态', remark: '字典:studio_status', default: '1' })
  exam_status: string;
  @prop({ required: false, index: true, zh: '身份证号', unique: true })
  card: string;
  @prop({"required":false,"index":true,"zh":"是否入驻科学家工作室","default":"N"})
  is_studio: string
}
