import { OmitDto, Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
export class FetchVO_admin {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
  @ApiProperty({ description: '超级管理员!' })
  'is_super': boolean = undefined;
}

export class LoginVO extends FetchVO_admin {
  constructor(data: object) {
    super(data);
    if (_.get(data, 'is_super')) this.role_type = '0';
    else this.role_type = '1';
  }
  @ApiProperty({ description: '账号类型' })
  'role_type': string = undefined;
}

export class QueryDTO_admin extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['account', 'name', 'is_super'];
    super({ like_prop, props });
  }
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '超级管理员!' })
  'is_super': boolean = undefined;
}

export class QueryVO_admin extends FetchVO_admin {}

export class CreateDTO_admin {
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().required())
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().required())
  'name': string = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['array']().empty(''))
  'role': Array<any> = undefined;
}

export class CreateVO_admin extends FetchVO_admin {}

export class UpdateDTO_admin extends OmitDto(CreateDTO_admin, ['password']) {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_admin extends FetchVO_admin {}

export class LoginDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}

export class ResetPasswordDTO {
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
