import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_commonProblem {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '维护人' })
  'user_id': string = undefined;
  @ApiProperty({ description: '维护人姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '模块' })
  'model': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
  @ApiProperty({ description: '问题管理' })
  'problem': Array<any> = undefined;
}


export class QDTO_commonProblem extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['user_id', 'user_name', 'model', 'sort', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '维护人' })
  'user_id': string = undefined;
  @ApiProperty({ description: '维护人姓名' })
  'user_name': string = undefined;
  @ApiProperty({ description: '模块' })
  'model': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}


export class QVO_commonProblem extends FVO_commonProblem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}


export class CDTO_commonProblem {
  @ApiProperty({ description: '维护人' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '维护人姓名' })
  @Rule(RuleType['string']().empty(''))
  'user_name': string = undefined;
  @ApiProperty({ description: '模块' })
  @Rule(RuleType['string']().empty(''))
  'model': string = undefined;
  @ApiProperty({ description: '排序' })
  @Rule(RuleType['number']().empty(''))
  'sort': number = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
  @ApiProperty({ description: '问题管理' })
  @Rule(RuleType['array']().empty(''))
  'problem': Array<any> = undefined;
}


export class CVO_commonProblem extends FVO_commonProblem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}


export class UDTO_commonProblem extends CDTO_commonProblem {
    @ApiProperty({ description: '数据id' })
    @Rule(RuleType['string']().empty(''))
    _id: string = undefined;
}


export class UVAO_commonProblem extends FVO_commonProblem {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
