import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import {  SearchBase } from 'free-midway-component';
export class FetchVO_dictData {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '字典排序' })
  'dict_sort': number = undefined;
  @ApiProperty({ description: '字典内容名' })
  'dict_label': string = undefined;
  @ApiProperty({ description: '字典内容值' })
  'dict_value': string = undefined;
  @ApiProperty({ description: '字典索引类型' })
  'dict_type': string = undefined;
  @ApiProperty({ description: '是否默认' })
  'is_default': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QueryDTO_dictData extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['dict_sort', 'dict_label', 'is_default', 'status', 'dict_type'];
    super({ like_prop, props });
  }
  @ApiProperty({ description: '字典排序' })
  'dict_sort': number = undefined;
  @ApiProperty({ description: '字典内容名' })
  'dict_label': string = undefined;
  @ApiProperty({ description: '字典类型' })
  'dict_type': string = undefined;
  @ApiProperty({ description: '是否默认' })
  'is_default': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QueryVO_dictData extends FetchVO_dictData {}

export class CreateDTO_dictData {
  @ApiProperty({ description: '字典排序' })
  @Rule(RuleType['number']().empty(''))
  'dict_sort': number = undefined;
  @ApiProperty({ description: '字典内容名' })
  @Rule(RuleType['string']().empty(''))
  'dict_label': string = undefined;
  @ApiProperty({ description: '字典内容值' })
  @Rule(RuleType['string']().empty(''))
  'dict_value': string = undefined;
  @ApiProperty({ description: '字典索引类型' })
  @Rule(RuleType['string']().empty(''))
  'dict_type': string = undefined;
  @ApiProperty({ description: '是否默认' })
  @Rule(RuleType['string']().empty(''))
  'is_default': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CreateVO_dictData extends FetchVO_dictData {}

export class UpdateDTO_dictData extends CreateDTO_dictData {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_dictData extends FetchVO_dictData {}
