import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
export class FetchVO_dictType {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '字典索引名' })
  'dict_name': string = undefined;
  @ApiProperty({ description: '字典类型' })
  'dict_type': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QueryDTO_dictType extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['dict_name', 'dict_type', 'status'];
    super({ like_prop, props });
  }
  @ApiProperty({ description: '字典索引名' })
  'dict_name': string = undefined;
  @ApiProperty({ description: '字典类型' })
  'dict_type': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QueryVO_dictType extends FetchVO_dictType {}

export class CreateDTO_dictType {
  @ApiProperty({ description: '字典索引名' })
  @Rule(RuleType['string']().empty(''))
  'dict_name': string = undefined;
  @ApiProperty({ description: '字典类型' })
  @Rule(RuleType['string']().empty(''))
  'dict_type': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CreateVO_dictType extends FetchVO_dictType {}

export class UpdateDTO_dictType extends CreateDTO_dictType {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_dictType extends FetchVO_dictType {}
