import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
export class FetchVO_menus {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '菜单名称' })
  'name': string = undefined;
  @ApiProperty({ description: '模块id' })
  'module_id': string = undefined;
  @ApiProperty({ description: '父级菜单' })
  'parent_id': string = undefined;
  @ApiProperty({ description: '显示顺序' })
  'order_num': number = undefined;
  @ApiProperty({ description: '路由地址' })
  'path': string = undefined;
  @ApiProperty({ description: '组件地址' })
  'component': string = undefined;
  @ApiProperty({ description: '菜单类型' })
  'type': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '图标' })
  'icon': string = undefined;
  @ApiProperty({ description: '设置' })
  'config': object = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
}

export class QueryDTO_menus extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'module_id', 'parent_id', 'status'];
    super({ like_prop, props });
  }
  @ApiProperty({ description: '菜单名称' })
  'name': string = undefined;
  @ApiProperty({ description: '模块id' })
  'module_id': string = undefined;
  @ApiProperty({ description: '父级菜单' })
  'parent_id': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QueryVO_menus extends FetchVO_menus {}

export class CreateDTO_menus {
  @ApiProperty({ description: '菜单名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '模块id' })
  @Rule(RuleType['string']().empty(''))
  'module_id': string = undefined;
  @ApiProperty({ description: '父级菜单' })
  @Rule(RuleType['string']().empty(''))
  'parent_id': string = undefined;
  @ApiProperty({ description: '父级名称' })
  @Rule(RuleType['string']().empty(''))
  'parent_name': string = undefined;
  @ApiProperty({ description: '显示顺序' })
  @Rule(RuleType['number']().empty(''))
  'order_num': number = undefined;
  @ApiProperty({ description: '路由地址' })
  @Rule(RuleType['string']().empty(''))
  'path': string = undefined;
  @ApiProperty({ description: '组件地址' })
  @Rule(RuleType['string']().empty(''))
  'component': string = undefined;
  @ApiProperty({ description: '菜单类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '图标' })
  @Rule(RuleType['string']().empty(''))
  'icon': string = undefined;
  @ApiProperty({ description: '设置' })
  @Rule(RuleType['object']().empty(''))
  'config': object = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
}

export class CreateVO_menus extends FetchVO_menus {}

export class UpdateDTO_menus extends CreateDTO_menus {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_menus extends FetchVO_menus {}
