import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
export class FetchVO_module {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '模块名称' })
  'name': string = undefined;
  @ApiProperty({ description: '模块地址' })
  'url': string = undefined;
  @ApiProperty({ description: '模块简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QueryDTO_module extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'is_use'];
    super({ like_prop, props });
  }
  @ApiProperty({ description: '模块名称' })
  'name': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QueryVO_module extends FetchVO_module {}

export class CreateDTO_module {
  @ApiProperty({ description: '模块名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '模块地址' })
  @Rule(RuleType['string']().empty(''))
  'url': string = undefined;
  @ApiProperty({ description: '模块简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CreateVO_module extends FetchVO_module {}

export class UpdateDTO_module extends CreateDTO_module {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_module extends FetchVO_module {}
