import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
export class FetchVO_role {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '角色名称' })
  'name': string = undefined;
  @ApiProperty({ description: '角色编码' })
  'code': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '菜单' })
  'menu': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '账号类型' })
  'account_type': string = undefined;
}

export class QueryDTO_role extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'code', 'status', 'account_type'];
    super({ like_prop, props });
  }
  @ApiProperty({ description: '角色名称' })
  'name': string = undefined;
  @ApiProperty({ description: '角色编码' })
  'code': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '账号类型' })
  'account_type': string = undefined;
}

export class QueryVO_role extends FetchVO_role {}

export class CreateDTO_role {
  @ApiProperty({ description: '角色名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '角色编码' })
  @Rule(RuleType['string']().empty(''))
  'code': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '菜单' })
  @Rule(RuleType['array']().empty(''))
  'menu': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '账号类型' })
  @Rule(RuleType['string']().empty(''))
  'account_type': string = undefined;
}

export class CreateVO_role extends FetchVO_role {}

export class UpdateDTO_role extends CreateDTO_role {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_role extends FetchVO_role {}
