import { OmitDto, Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
export class FetchVO_unit {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '负责人身份证号' })
  'card': string = undefined;
  @ApiProperty({ description: '负责人姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '负责人邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '负责人手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '单位全称' })
  'unit_name': string = undefined;
  @ApiProperty({ description: '单位地址' })
  'unit_address': string = undefined;
  @ApiProperty({ description: '负责人委任证明' })
  'prove': Array<any> = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
  @ApiProperty({ description: '审核状态' })
  'exam_status': string = undefined;
  @ApiProperty({ description: '是否入驻科学家工作室' })
  'is_studio': string = undefined;
}
export class LoginVO extends FetchVO_unit {
  constructor(data: object) {
    super(data);
    this.role_type = '3';
  }
  @ApiProperty({ description: '账号类型' })
  'role_type': string = undefined;
}

export class QueryDTO_unit extends SearchBase {
  constructor() {
    const like_prop = ['unit_name'];
    const props = ['account', 'name', 'phone','unit_name', 'exam_status', 'is_studio'];
    super({ like_prop, props });
  }
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '负责人姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '管理员手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '单位全称' })
  'unit_name': string = undefined;
  @ApiProperty({ description: '审核状态' })
  'exam_status': string = undefined;
  @ApiProperty({ description: '是否入驻科学家工作室' })
  'is_studio': string = undefined;
}

export class QueryVO_unit extends FetchVO_unit {}

export class CreateDTO_unit {
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().required())
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
  @ApiProperty({ description: '负责人姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '昵称' })
  @Rule(RuleType['string']().empty(''))
  'nick_name': string = undefined;
  @ApiProperty({ description: '负责人邮箱' })
  @Rule(RuleType['string']().required())
  'email': string = undefined;
  @ApiProperty({ description: '单位全称' })
  @Rule(RuleType['string']().required())
  'unit_name': string = undefined;
  @ApiProperty({ description: '单位地址' })
  @Rule(RuleType['string']().empty(''))
  'unit_address': string = undefined;
  @ApiProperty({ description: '负责人委任证明' })
  @Rule(RuleType['array']().empty(''))
  'prove': Array<any> = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['array']().empty(''))
  'role': Array<any> = undefined;
  @ApiProperty({ description: '审核状态' })
  @Rule(RuleType['string']().empty(''))
  'exam_status': string = undefined;
  @ApiProperty({ description: '负责人身份证号' })
  @Rule(RuleType['string']().empty(''))
  'card': string = undefined;
  @ApiProperty({ description: '负责人手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @Rule(RuleType['string']().empty(''))
  'is_studio': string = undefined;
}

export class CreateVO_unit extends FetchVO_unit {}

export class UpdateDTO_unit extends OmitDto(CreateDTO_unit, ['password', 'email']) {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
  @ApiProperty({ description: '负责人邮箱' })
  @Rule(RuleType['string']().empty())
  'email': string = undefined;
}

export class UpdateVO_unit extends FetchVO_unit {}

export class LoginDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}
export class UnitForgetEmailDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().required())
  'account': string = undefined;
}

export class EmailResetPasswordDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().required())
  'account': string = undefined;
  @ApiProperty({ description: '验证码', example: 'code' })
  @Rule(RuleType['string']().required())
  'code': string = undefined;
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}

export class ResetPasswordDTO {
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
