import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
import isArray = require('lodash/isArray');
import get = require('lodash/get');
export class FetchVO_unitStudioApply {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '单位全称' })
  'company': string = undefined;
  @ApiProperty({ description: '单位地址' })
  'address': string = undefined;
  @ApiProperty({ description: '单位法人姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '单位法人手机号码' })
  'phone': string = undefined;
  @ApiProperty({ description: '法人身份证' })
  'card': Array<any> = undefined;
  @ApiProperty({ description: '单位联系人' })
  'unit_contact': string = undefined;
  @ApiProperty({ description: '单位联系电话' })
  'unit_phone': object = undefined;
  @ApiProperty({ description: '单位电子邮箱' })
  'unit_email': object = undefined;
  @ApiProperty({ description: '行业领域' })
  'fields': Array<any> = undefined;
  @ApiProperty({ description: '技术需求方向' })
  'direction': Array<any> = undefined;
  @ApiProperty({ description: '上一年度财务审计报告' })
  'audit_report': Array<any> = undefined;
  @ApiProperty({ description: '上一年度R&D投入专项' })
  'special_report': Array<any> = undefined;
  @ApiProperty({ description: '其他证明资料' })
  'prove_file': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '账号id' })
  'unit_id': string = undefined;
}

export class QueryDTO_unitStudioApply extends SearchBase {
  constructor() {
    const like_prop = ['direction'];
    const props = ['fields', 'direction', 'company', 'phone', 'status', 'unit_id', 'unit_contact', 'unit_phone', 'unit_email'];
    const mapping = {
      unit_phone: 'unit_phone.phone',
      unit_email: 'unit_email.email',
      direction: 'direction.name',
    };
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '单位全称' })
  'company': string = undefined;
  @ApiProperty({ description: '单位法人手机号码' })
  'phone': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '账号id' })
  'unit_id': string = undefined;

  @ApiProperty({ description: '单位联系人' })
  'unit_contact': string = undefined;
  @ApiProperty({ description: '单位联系电话' })
  'unit_phone': string = undefined;
  @ApiProperty({ description: '单位电子邮箱' })
  'unit_email': string = undefined;

  @ApiProperty({ description: '行业领域' })
  'fields': string = undefined;
  @ApiProperty({ description: '技术需求方向' })
  'direction': string = undefined;
}

export class QueryVO_unitStudioApply extends FetchVO_unitStudioApply {
  constructor(data: object, filter: object) {
    super(data);
    if (isArray(this.fields) && get(filter, 'fields')) {
      this.fields = this.fields.filter(f => f === get(filter, 'fields'));
    }
    if (isArray(this.direction) && get(filter, 'direction')) {
      this.direction = this.direction.filter(f => f.name.includes(get(filter, 'direction')));
    }
  }
}

export class CreateDTO_unitStudioApply {
  @ApiProperty({ description: '单位全称' })
  @Rule(RuleType['string']().empty(''))
  'company': string = undefined;
  @ApiProperty({ description: '单位地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '单位法人姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '单位法人手机号码' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '法人身份证' })
  @Rule(RuleType['array']().empty(''))
  'card': Array<any> = undefined;
  @ApiProperty({ description: '行业领域' })
  @Rule(RuleType['array']().empty(''))
  'fields': Array<any> = undefined;
  @ApiProperty({ description: '技术需求方向' })
  @Rule(RuleType['array']().empty(''))
  'direction': Array<any> = undefined;
  @ApiProperty({ description: '上一年度财务审计报告' })
  @Rule(RuleType['array']().empty(''))
  'audit_report': Array<any> = undefined;
  @ApiProperty({ description: '上一年度R&D投入专项' })
  @Rule(RuleType['array']().empty(''))
  'special_report': Array<any> = undefined;
  @ApiProperty({ description: '其他证明资料' })
  @Rule(RuleType['array']().empty(''))
  'prove_file': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '账号id' })
  @Rule(RuleType['string']().empty(''))
  'unit_id': string = undefined;

  @ApiProperty({ description: '单位联系人' })
  @Rule(RuleType['string']().empty(''))
  'unit_contact': string = undefined;
  @ApiProperty({ description: '单位联系电话' })
  @Rule(RuleType['object']().empty(''))
  'unit_phone': object = undefined;
  @ApiProperty({ description: '单位电子邮箱' })
  @Rule(RuleType['object']().empty(''))
  'unit_email': object = undefined;
}

export class CreateVO_unitStudioApply extends FetchVO_unitStudioApply {}

export class UpdateDTO_unitStudioApply extends CreateDTO_unitStudioApply {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_unitStudioApply extends FetchVO_unitStudioApply {}
