import { OmitDto, Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
export class FetchVO_user {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '单位地址' })
  'unit_address': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
  @ApiProperty({ description: '审核状态' })
  'exam_status': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'card': string = undefined;
  @ApiProperty({ description: '是否入驻科学家工作室' })
  'is_studio': string = undefined;
}

export class LoginVO {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
    this.role_type = '2';
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '昵称' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
  @ApiProperty({ description: '账号类型' })
  'role_type': string = undefined;
  @ApiProperty({ description: '实验室数据id' })
  'lab_id': string = undefined;
  @ApiProperty({ description: '项目管理数据id' })
  'basic_id': string = undefined;
  @ApiProperty({ description: '入口' })
  'entrances': object = undefined;
  @ApiProperty({ description: '邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '单位地址' })
  'unit_address': string = undefined;
  @ApiProperty({ description: '审核状态' })
  'exam_status': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'card': string = undefined;
}

export class QueryDTO_user extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['account', 'nick_name','card', 'phone', 'unit', 'exam_status', 'is_studio'];
    super({ like_prop, props });
  }
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '姓名' })
  'nick_name': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '单位' })
  'unit': string = undefined;
  @ApiProperty({ description: '审核状态' })
  'exam_status': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'card': string = undefined;
  @ApiProperty({ description: '是否入驻科学家工作室' })
  'is_studio': string = undefined;
}

export class QueryVO_user extends FetchVO_user {
  @ApiProperty({ description: '企业名称' })
  'unit_name': string = undefined;
}

export class CreateDTO_user {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '手机号', example: '13089419810' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '邮箱', example: '402788946@qq.com' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '单位', example: '长春市福瑞科技有限公司' })
  @Rule(RuleType['string']().empty(''))
  'unit': string = undefined;
  @ApiProperty({ description: '单位地址', example: '不知道' })
  @Rule(RuleType['string']().empty(''))
  'unit_address': string = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['array']().empty(''))
  'role': Array<any> = undefined;
  @ApiProperty({ description: '审核状态' })
  @Rule(RuleType['string']().empty(''))
  'exam_status': string = undefined;
  @ApiProperty({ description: '昵称' })
  @Rule(RuleType['string']().empty(''))
  'nick_name': string = undefined;
  @ApiProperty({ description: '身份证号' })
  @Rule(RuleType['string']().empty(''))
  'card': string = undefined;
  @Rule(RuleType['string']().empty(''))
  'is_studio': string = undefined;
}

export class CreateVO_user extends FetchVO_user {}

export class UpdateDTO_user extends OmitDto(CreateDTO_user, ['password']) {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_user extends FetchVO_user {}

export class LoginDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}

export class UserForgetEmailDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().required())
  'account': string = undefined;
}

export class EmailResetPasswordDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().required())
  'account': string = undefined;
  @ApiProperty({ description: '验证码', example: 'code' })
  @Rule(RuleType['string']().required())
  'code': string = undefined;
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
export class ResetPasswordDTO {
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
