import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import _ = require('lodash');
import { SearchBase } from 'free-midway-component';
import isArray = require('lodash/isArray');
import get = require('lodash/get');
export class FetchVO_userStudioApply {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = _.get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '出生年月' })
  'brith': string = undefined;
  @ApiProperty({ description: '居住地' })
  'live_place': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': object = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': object = undefined;
  @ApiProperty({ description: '上传身份证照片' })
  'card': Array<any> = undefined;
  @ApiProperty({ description: '团队联系人' })
  'team_name': string = undefined;
  @ApiProperty({ description: '团队联系电话' })
  'team_phone': object = undefined;
  @ApiProperty({ description: '所在单位全称' })
  'company': string = undefined;
  @ApiProperty({ description: '所在单位地址' })
  'address': string = undefined;
  @ApiProperty({ description: '专业技术职称' })
  'zc': string = undefined;
  @ApiProperty({ description: '职称证明' })
  'zc_file': Array<any> = undefined;
  @ApiProperty({ description: '社会兼职' })
  'part_job': string = undefined;
  @ApiProperty({ description: '研究领域' })
  'fields': Array<any> = undefined;
  @ApiProperty({ description: '研究方向' })
  'direction': Array<any> = undefined;
  @ApiProperty({ description: '服务企业代表性案例' })
  'case': Array<any> = undefined;
  @ApiProperty({ description: '案例证明材料' })
  'case_file': Array<any> = undefined;
  @ApiProperty({ description: '是否为在职人员' })
  'is_job': string = undefined;
  @ApiProperty({ description: '单位同意入驻证明' })
  'settle_file': Array<any> = undefined;
  @ApiProperty({ description: '上传职称证明' })
  'job_zc_file': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '账号id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '学历' })
  'education': string = undefined;
  @ApiProperty({ description: '学位' })
  'degree': string = undefined;
}

export class QueryDTO_userStudioApply extends SearchBase {
  constructor() {
    const like_prop = ['direction','name'];
    const props = ['fields', 
    'direction', 
    'name', 
    'brith', 
    'live_place', 
    'phone', 'email', 
    'team_name', 'team_phone', 
    'company', 'address', 'zc', 'part_job', 'is_job', 'status', 'user_id', 'education', 'degree'];
    const mapping = {
      phone: 'phone.phone',
      email: 'email.email',
      team_phone: 'team_phone.phone',
      direction: 'direction.name',
    };
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '出生年月' })
  'brith': string = undefined;
  @ApiProperty({ description: '居住地' })
  'live_place': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '团队联系人' })
  'team_name': string = undefined;
  @ApiProperty({ description: '团队联系电话' })
  'team_phone': string = undefined;
  @ApiProperty({ description: '所在单位全称' })
  'company': string = undefined;
  @ApiProperty({ description: '所在单位地址' })
  'address': string = undefined;
  @ApiProperty({ description: '专业技术职称' })
  'zc': string = undefined;
  @ApiProperty({ description: '社会兼职' })
  'part_job': string = undefined;
  @ApiProperty({ description: '是否为在职人员' })
  'is_job': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '账号id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '学历' })
  'education': string = undefined;
  @ApiProperty({ description: '学位' })
  'degree': string = undefined;
}

export class QueryVO_userStudioApply extends FetchVO_userStudioApply {
  constructor(data: object, filter: object) {
    super(data);
    if (isArray(this.fields) && get(filter, 'fields')) {
      this.fields = this.fields.filter(f => f === get(filter, 'fields'));
    }
    if (isArray(this.direction) && get(filter, 'direction')) {
      this.direction = this.direction.filter(f => f.name.includes(get(filter, 'direction')));
    }
  }
}

export class CreateDTO_userStudioApply {
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '出生年月' })
  @Rule(RuleType['string']().empty(''))
  'brith': string = undefined;
  @ApiProperty({ description: '居住地' })
  @Rule(RuleType['string']().empty(''))
  'live_place': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['object']().empty(''))
  'phone': object = undefined;
  @ApiProperty({ description: '电子邮箱' })
  @Rule(RuleType['object']().empty(''))
  'email': object = undefined;
  @ApiProperty({ description: '上传身份证照片' })
  @Rule(RuleType['array']().empty(''))
  'card': Array<any> = undefined;
  @ApiProperty({ description: '团队联系人' })
  @Rule(RuleType['string']().empty(''))
  'team_name': string = undefined;
  @ApiProperty({ description: '团队联系电话' })
  @Rule(RuleType['object']().empty(''))
  'team_phone': object = undefined;
  @ApiProperty({ description: '所在单位全称' })
  @Rule(RuleType['string']().empty(''))
  'company': string = undefined;
  @ApiProperty({ description: '所在单位地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '专业技术职称' })
  @Rule(RuleType['string']().empty(''))
  'zc': string = undefined;
  @ApiProperty({ description: '职称证明' })
  @Rule(RuleType['array']().empty(''))
  'zc_file': Array<any> = undefined;
  @ApiProperty({ description: '社会兼职' })
  @Rule(RuleType['string']().empty(''))
  'part_job': string = undefined;
  @ApiProperty({ description: '研究领域' })
  @Rule(RuleType['array']().empty(''))
  'fields': Array<any> = undefined;
  @ApiProperty({ description: '研究方向' })
  @Rule(RuleType['array']().empty(''))
  'direction': Array<any> = undefined;
  @ApiProperty({ description: '服务企业代表性案例' })
  @Rule(RuleType['array']().empty(''))
  'case': Array<any> = undefined;
  @ApiProperty({ description: '案例证明材料' })
  @Rule(RuleType['array']().empty(''))
  'case_file': Array<any> = undefined;
  @ApiProperty({ description: '是否为在职人员' })
  @Rule(RuleType['string']().empty(''))
  'is_job': string = undefined;
  @ApiProperty({ description: '单位同意入驻证明' })
  @Rule(RuleType['array']().empty(''))
  'settle_file': Array<any> = undefined;
  @ApiProperty({ description: '上传职称证明' })
  @Rule(RuleType['array']().empty(''))
  'job_zc_file': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '账号id' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @Rule(RuleType['string']().empty(''))
  'education': string = undefined;
  @ApiProperty({ description: '学位' })
  @Rule(RuleType['string']().empty(''))
  'degree': string = undefined;
}

export class CreateVO_userStudioApply extends FetchVO_userStudioApply {}

export class UpdateDTO_userStudioApply extends CreateDTO_userStudioApply {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UpdateVO_userStudioApply extends FetchVO_userStudioApply {}
