import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService, FrameworkErrorEnum, ServiceError } from 'free-midway-component';
import { Admin } from '../entity/admin.entity';
import { LoginDTO } from '../interface/admin.interface';
import isEqual = require('lodash/isEqual');
type modelType = ReturnModelType<typeof Admin>;
@Provide()
export class AdminService extends BaseService<modelType> {
  @InjectEntityModel(Admin)
  model: modelType;

  async findUserToLogin(data: LoginDTO): Promise<object> {
    const { account, password } = data;
    const user = await this.model.findOne({ account }, '+password').lean();
    if (!user) throw new ServiceError('未找到用户信息', FrameworkErrorEnum.NOT_FOUND_DATA);
    if (!isEqual(user.password.secret, password)) throw new ServiceError('密码错误', FrameworkErrorEnum.SERVICE_FAULT);
    return user;
  }

  async initSuper() {
    const data = {
      account: 'sadmin',
      password: 'lcLL514vkG',
      name: '超级管理员',
      is_super: true,
    };
    const is_exist = await this.model.count({ is_super: true });
    if (!is_exist) await this.model.create(data);
    return;
  }
}
