import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { UserStudioApply } from '../entity/userStudioApply.entity';
import { Scientistsettle } from '../entityStudio/scientistsettle.entity';
type modelType = ReturnModelType<typeof UserStudioApply>;
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
@Provide()
export class UserStudioApplyService extends BaseService<modelType> {
  @InjectEntityModel(UserStudioApply)
  model: modelType;

  @InjectEntityModel(Scientistsettle)
  ssModel: ReturnModelType<typeof Scientistsettle>;
  /**
   * 查询可以入驻工作室的权限列表
   * @param company_id 企业id
   */
  async getListForSelect(company_id: string): Promise<Array<any>> {
    const result: Array<any> = [];
    const usaList = await this.model.find({ status: '1' }).lean();
    const ssList = await this.ssModel.find({ company_id, scientist_id: usaList.map(i => new ObjectId(i._id).toString()) }).lean();
    for (const usa of usaList) {
      const r = ssList.findIndex(f => new ObjectId(f.scientist_id).equals(usa._id));
      if (r < 0) result.push(usa);
    }
    return result;
  }
}
